/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2007 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: h8_sci.c 793 2008-03-16 14:06:04Z hiro $
 */

/*
 *   H8 SCI ʰSIOɥ饤
 *
 *    ݡȤ 1ܤξ HWPORT1_ADDR˻ꤵ줿ݡȤѤ
 *      2ܤξϡHWPORT1_ADDR桼ѡHWPORT2_ADDR򥳥󥽡
 *      ϤȤƻѤ롣
 *      HWPORTx_ADDR åȰ¸ sys_config.hǻꤹ롣
 *    Υ⥸塼ˤäơXON/XOFFե椬Ԥ
 *      ƤΤǡTxDRxD2ܤǤ褤
 */

#include <sil.h>
#include "target_syssvc.h"

#include "target_serial.h"
#include <kernel.h>
#include "t_syslog.h"		/*  TOPPERS_assert_fail  */

#include "target_rename.h"
#include "target_config.h"

#include "h8_sci.h"

/*
 *  ܡ졼Ȥ1ӥåʬλ[nsec]Ѵޥ
 *  黻ǥСեʤ褦ulong_tѤƤ
 */
#define BAUD_TO_NSEC(b)       (ulong_t)(((1000000UL / (b)) + 1UL) * 1000UL)

/*
 *  ܡ졼ȤBRRͤѴޥ
 */
#define H8BRR_RATE(b)	(((b)>38400U)?((uint8_t)(((CPU_CLOCK+(16U*(b)))/(32U*(b)))-1U))\
			          :((uint8_t)((CPU_CLOCK/(32U*(b)))-1U)))

/*
 *  ꥢI/OݡȽ֥å
 */
static const SIOPINIB siopinib_table[TNUM_SIOP_H8_SCI] = {
    {
		(uint8_t *)SYSTEM_SCI,
		SYSTEM_BAUD_RATE,
		SYSTEM_SCI_SMR
	}

#if TNUM_SIOP_H8_SCI >= 2
	,{
		(uint8_t *)USER_SCI,
		USER_BAUD_RATE,
		USER_SCI_SMR
	}
#endif	/* of #if TNUM_SIOP_H8_SCI >= 2 */

#if TNUM_SIOP_H8_SCI >= 3
	,{
		(uint8_t *)USER2_SCI,
		USER2_BAUD_RATE,
		USER2_SCI_SMR
	}
#endif	/* of #if TNUM_SIOP_H8_SCI >= 3 */
};


/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
static SIOPCB	siopcb_table[TNUM_SIOP_H8_SCI];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)	 ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)	 (&(siopcb_table[INDEX_SIOP(siopid)]))
#define get_siopinib(siopid) (&(siopinib_table[INDEX_SIOP(siopid)]))

/*
 *  ʸ
 */
Inline bool_t
h8_sci_getready(SIOPCB *p_siopcb)
{
	uint8_t *p_ssr = p_siopcb->siopinib->p_base + H8SSR;
	uint8_t ssr = sil_reb_mem(p_ssr);
	return ((ssr & H8SSR_RDRF) != 0);
}

/*
 *  ʸǤ뤫
 */
Inline bool_t
h8_sci_putready(SIOPCB *p_siopcb)
{
	uint8_t *p_ssr = p_siopcb->siopinib->p_base + H8SSR;
	uint8_t ssr = sil_reb_mem(p_ssr);
	return ((ssr & H8SSR_TDRE) != 0);
}

/*
 *  ʸμФ
 */
Inline unsigned char
h8_sci_getchar(SIOPCB *p_siopcb)
{
	uint8_t *p_base = p_siopcb->siopinib->p_base;
    uint8_t ch = sil_reb_mem(p_base + H8RDR);
	bitclr(p_base + H8SSR, H8SSR_RDRF_BIT);
	return ch;
}

/*
 *  ʸν
 */
Inline void
h8_sci_putchar(SIOPCB *p_siopcb, char c)
{
	uint8_t *p_base = p_siopcb->siopinib->p_base;

	sil_wrb_mem(p_base + H8TDR, (uint8_t)c);
	bitclr(p_base + H8SSR, H8SSR_TDRE_BIT);
}

/*
 *  ߵ
 */
Inline void
h8_sci_enable_send(SIOPCB *p_siopcb)
{
	uint8_t *p_scr = p_siopcb->siopinib->p_base + H8SCR;
	bitset(p_scr, H8SCR_TIE_BIT);
}

/*
 *  ߶ػ
 */
Inline void
h8_sci_disable_send(SIOPCB *p_siopcb)
{
	uint8_t *p_scr = p_siopcb->siopinib->p_base + H8SCR;
	bitclr(p_scr, H8SCR_TIE_BIT);
}


/*
 *  ߵ
 */
Inline void
h8_sci_enable_rcv(SIOPCB *p_siopcb)
{
	uint8_t *p_scr = p_siopcb->siopinib->p_base + H8SCR;
	bitset(p_scr, H8SCR_RIE_BIT);
}

/*
 *  ߶ػ
 */
Inline void
h8_sci_disable_rcv(SIOPCB *p_siopcb)
{
	uint8_t *p_scr = p_siopcb->siopinib->p_base + H8SCR;
	bitclr(p_scr, H8SCR_RIE_BIT);
}

/*
 *  SIOɥ饤Фν
 */
void
h8_sci_initialize(intptr_t exinf)
{
	SIOPCB	*p_siopcb;
	uint_t	i;

	/*
	 *  ꥢI/Oݡȴ֥åν
	 */
    for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP_H8_SCI; p_siopcb++, i++) {
        p_siopcb->siopinib = &(siopinib_table[i]);
        p_siopcb->openflag = false;
        p_siopcb->sendflag = false;
    }
}


/*
 * ϡɥν
 */
static void
h8_sci_init_siopinib(const SIOPINIB *p_siopinib)
{
	uint8_t *p_base = p_siopinib->p_base;

	/* 		*/
	sil_anb_reg((p_base + H8SCR),
	           (uint8_t)~(H8SCR_TIE | H8SCR_RIE | H8SCR_TE | H8SCR_RE));

	/*
	 *⡼
	 *ĴƱ
	 *饯Ĺ
	 *ѥƥ
	 *ȥåץӥåĹ
	 *å
	 */
	sil_wrb_mem(p_base + H8SMR, p_siopinib->smr_init);

	/*  ܡ졼  	*/
	assert(H8BRR_RATE(p_siopinib->baudrate) < 0xff);
	sil_wrb_mem(p_base + H8BRR, (uint8_t)H8BRR_RATE(p_siopinib->baudrate));

	/* ߶ػߤȥå	*/
	sil_anb_reg(p_base + H8SCR,
            	    (uint8_t)~(H8SCR_TIE  | H8SCR_RIE  | H8SCR_MPIE |
            	          H8SCR_TEIE | H8SCR_CKE1 | H8SCR_CKE0 ));

	/* ܡ졼Ȥ塢1ӥåʬԤʤФʤʤ*/
	sil_dly_nse(BAUD_TO_NSEC(p_siopinib->baudrate));

	/* 顼ե饰򥯥ꥢ		*/
	sil_anb_reg(p_base + H8SSR,
	            (uint8_t)~(H8SSR_ORER | H8SSR_FER | H8SSR_PER));

	/* ߤߤεĤϥꥢ I/O ǹԤ */
	/*  */
	sil_orb_reg(p_base + H8SCR, (H8SCR_TE | H8SCR_RE));
}


/*
 * ͥ뵯ưΥСʽѤν
 */
void
h8_sci_init(uint8_t portno)
{
    h8_sci_init_siopinib(get_siopinib(portno));
}


/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
h8_sci_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB          *p_siopcb;
    const SIOPINIB  *p_siopinib;
      
    p_siopcb = get_siopcb(siopid);
    p_siopinib = p_siopcb->siopinib;

    /*
     * 
     */
    h8_sci_init_siopinib(p_siopinib);

    p_siopcb->exinf = exinf;
    p_siopcb->getready = p_siopcb->putready = false;
    p_siopcb->openflag = true;

    return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
h8_sci_cls_por(SIOPCB *p_siopcb)
{
    const SIOPINIB  *p_siopinib = p_siopcb->siopinib;
	uint8_t *p_base = p_siopinib->p_base;

	/* TDRE  1 ˤʤޤԤ */
	while ((sil_reb_mem(p_base + H8SSR) & H8SSR_TDRE) == 0)
		;

	/* 11ӥåʬԤġ*/
	sil_dly_nse(11UL * BAUD_TO_NSEC(p_siopinib->baudrate));
					/* 		*/
	sil_anb_reg(p_base + H8SCR,
	           (uint8_t)~(H8SCR_TIE | H8SCR_RIE | H8SCR_TE | H8SCR_RE));
    p_siopcb->openflag = false;
}


/*
 *  ꥢI/OݡȤؤΥݡ󥰤Ǥν
 */
void
h8_sci_pol_putc(char c, ID siopid)
{
    const SIOPINIB *p_siopinib;
    uint8_t *p_base, *p_ssr;

    p_siopinib = get_siopinib(siopid);
	p_base = p_siopinib->p_base;
	p_ssr = p_base + H8SSR;

	/* TDRE  1 ˤʤޤԤ */
	while ((sil_reb_mem(p_ssr) & H8SSR_TDRE) == 0)
		;
	sil_wrb_mem(p_base + H8TDR, (uint8_t)c);
	bitclr(p_ssr, H8SSR_TDRE_BIT);
}


/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
h8_sci_snd_chr(SIOPCB *p_siopcb, char c)
{
    if (h8_sci_putready(p_siopcb)){
        h8_sci_putchar(p_siopcb, c);
        return true;
	}
    return false;
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
h8_sci_rcv_chr(SIOPCB *p_siopcb)
{
	if (h8_sci_getready(p_siopcb)) {
		/*  uint8_t˥㥹ȤΤĥɤ  */
		return((int_t)(uint8_t) h8_sci_getchar(p_siopcb));
	}
	return(-1);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
h8_sci_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        h8_sci_enable_send(p_siopcb);
        break;
      case SIO_RDY_RCV:
        h8_sci_enable_rcv(p_siopcb);
        break;
	}
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
h8_sci_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
      case SIO_RDY_SND:
        h8_sci_disable_send(p_siopcb);
        break;
      case SIO_RDY_RCV:
        h8_sci_disable_rcv(p_siopcb);
        break;
    }
}

/*
 *  SIOߥӥ롼
 */
void
h8_sci_tx_isr(ID siopid)
{
    SIOPCB	*p_siopcb = get_siopcb(siopid);

    if (h8_sci_putready(p_siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        h8_sci_ierdy_snd(p_siopcb->exinf);
	}
}


/*
 *  SIOμߥӥ롼
 */
void
h8_sci_rx_isr(ID siopid)
{
    SIOPCB	*p_siopcb = get_siopcb(siopid);

    if (h8_sci_getready(p_siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
		 */
        h8_sci_ierdy_rcv(p_siopcb->exinf);
	}
}

#ifdef TOPPERS_H8_CFG_SCI_ERR_HANDLER

/*  顼ӥå  */
#define H8SSR_ERR_BIT_PTN	(H8SSR_ORER | H8SSR_FER | H8SSR_PER)
/*
 *  SIOΥ顼ߥӥ롼
 */
void
h8_sci_err_isr(ID siopid)
{
	uint8_t	status;
    SIOPCB	*p_siopcb;
    uint8_t *p_ssr;

    p_siopcb = get_siopcb(siopid);
    p_ssr = p_siopcb->siopinib->p_base + H8SSR;
	status = sil_reb_mem(p_ssr);
	if (status & H8SSR_ERR_BIT_PTN) {

		/* 顼		*/

	    	/* 顼ե饰򥯥ꥢ	*/
        status &= (uint8_t)~H8SSR_ERR_BIT_PTN;
		sil_wrb_mem(p_ssr, status);
	}
}

#endif	/* of #ifdef TOPPERS_H8_CFG_SCI_ERR_HANDLER */

