/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_timer.h 367 2008-05-24 18:47:58Z roi $
 */

/*
 *  ޥɥ饤СʽŻ AKI-H8/3069Fѡ
 */

#ifndef TOPPERS_TARGET_TIMER_H
#define TOPPERS_TARGET_TIMER_H

#include "h8300h_gcc/h8_3069f/h8_3069f.h"


/*
 *  ޤΥͥ
 *  016ӥåȥޡͥ0
 *  116ӥåȥޡͥ1
 *  216ӥåȥޡͥ2
 */
#define TOPPERS_TIMER_CH		0


#if !defined(TOPPERS_TIMER_CH) || (TOPPERS_TIMER_CH > 2)
#error Illegal timer channel no. (use 0, 1, 2.)
#endif

#if TOPPERS_TIMER_CH == 0

#define SYSTEM_TIMER			H816TU0
#define SYSTEM_TIMER_STR		H8TSTR_STR0
#define SYSTEM_TIMER_STR_BIT	H8TSTR_STR0_BIT
#define SYSTEM_TIMER_IE_BIT		H8TISRA_IMIEA0_BIT		/* interrupt mask */
#define SYSTEM_TIMER_IF			H8TISRA_IMFA0           /* match flag */
#define SYSTEM_TIMER_IF_BIT		H8TISRA_IMFA0_BIT
#define INTNO_TIMER     		TINTNO_IMIA0			/* ֹ */

#else /* TOPPERS_TIMER_CH == 0 */
#if TOPPERS_TIMER_CH == 1

#define SYSTEM_TIMER			H816TU1
#define SYSTEM_TIMER_STR		H8TSTR_STR1
#define SYSTEM_TIMER_STR_BIT	H8TSTR_STR1_BIT
#define SYSTEM_TIMER_IE_BIT		H8TISRA_IMIEA1_BIT		/* interrupt mask */
#define SYSTEM_TIMER_IF			H8TISRA_IMFA1           /* match flag */
#define SYSTEM_TIMER_IF_BIT		H8TISRA_IMFA1_BIT
#define INTNO_TIMER     		TINTNO_IMIA1			/* ֹ */

#else /* TOPPERS_TIMER_CH == 1 */
#if TOPPERS_TIMER_CH == 2

#define SYSTEM_TIMER			H816TU2
#define SYSTEM_TIMER_STR		H8TSTR_STR2
#define SYSTEM_TIMER_STR_BIT	H8TSTR_STR2_BIT
#define SYSTEM_TIMER_IE_BIT		H8TISRA_IMIEA2_BIT		/* interrupt mask */
#define SYSTEM_TIMER_IF			H8TISRA_IMFA2           /* match flag */
#define SYSTEM_TIMER_IF_BIT		H8TISRA_IMFA2_BIT
#define INTNO_TIMER     		TINTNO_IMIA2			/* ֹ */

#endif /* TOPPERS_TIMER_CH == 2 */
#endif /* TOPPERS_TIMER_CH == 1 */
#endif /* TOPPERS_TIMER_CH == 0 */


#define SYSTEM_TIMER_TCR_BIT	(H8TCR_CCLR0 | H8TCR_TPSC1 | H8TCR_TPSC0)
#define SYSTEM_TIMER_TIOR_BIT	(0)

#define TIMER_CLOCK		((CPU_CLOCK)/8000)		/* 8ʬ */

/*
 *  ޳ߥϥɥϿΤ
 */
#define INHNO_TIMER     INTNO_TIMER		/* ߥϥɥֹ */
#define INTPRI_TIMER    TMIN_INTPRI		/* ͥ */
#define INTATR_TIMER    0U				/* ° */

/*
 * ץå¸
 */
#include "h8300h_gcc/core_timer.h"

#endif /* TOPPERS_TARGET_TIMER_H */
